Summary: The PostgreSQL server programs.
Name: postgresql
Version: 6.5.3
Release: 1mdk
Copyright: BSD
Group: Databases
Source0: ftp://ftp.postgresql.org/pub/postgresql-%{version}.tar.bz2
Source1: ftp://www.flex.ro/pub/pgaccess/pgaccess-0.98.tar.bz2
Source2: http://www.retep.org.uk/postgres/jdbc6.5-1.1.jar
Source3: http://www.retep.org.uk/postgres/jdbc6.5-1.2.jar
Source4: postgresql.init.%{version}
Source5: PostgreSQL-HOWTO-html.tar.bz2
Source6: man.tar.bz2
Source7: README.rpm.postgresql-%{version}
Source8: pg-migration-scripts-%{version}.tar.bz2
Patch0: postgresql-%{version}-alpha.patch.bz2
Patch1: rpm-pgsql-%{version}.patch.bz2
Patch2: postgresql-6.5.2-pgaccess.patch.bz2
Patch4: mdkconf.patch.bz2
Patch5: postgresql-6.5.3-sparc64.patch.bz2
Prefix: /usr
Prereq: /sbin/chkconfig /sbin/ldconfig /usr/sbin/useradd
Url: http://www.ramifordistat.net/
ExcludeArch: armv4l
Obsoletes: postgresql-clients
Buildroot: /var/tmp/%{name}-root

%description
Postgresql includes the programs needed to create and run a PostgreSQL
server, which will in turn allow you to create and maintain PostgreSQL
databases.  PostgreSQL is an advanced Object-Relational database
management system (DBMS) that supports almost all SQL constructs
(including transactions, subselects and user-defined types and
functions).

You should install postgresql if you want to create and maintain your
own PostgreSQL databases and/or your own PostgreSQL server.  If you
are installing postgresql, you should also install postgresql-data,
which will help you get started with PostgreSQL.

%package server
Summary: The programs needed for a PostgreSQL server.
Group: Databases
Prereq: /usr/sbin/useradd
Requires: postgresql = %{version}

%description server
postgresql-server includes the programs needed to create and run a PostgreSQL
server, which will in turn allow you to create and maintain PostgreSQL
databases.  PostgreSQL is an advanced Object-Relational database
management system (DBMS) that supports almost all SQL constructs
(including transactions, subselects and user-defined types and
functions).

You should install postgresql if you want to create and maintain your
own PostgreSQL databases and/or your own PostgreSQL server.

%package devel
Summary: PostgreSQL development header files and libraries.
Group: Development/Databases
Requires: postgresql = %{version}

%description devel
This package contains the header files and libraries needed to compile
applications which will directly interact with a PostgreSQL server.

Install this package if you want to develop applications which will
interact with a PostgreSQL server.

%package tcl
Summary: The tcl-based client programs needed for accessing a PostgreSQL server.
Group: Development/Databases
Requires: tcl >= 8.0, tk >= 8.0, postgresql = %{version}

%description tcl
postgresql-tcl includes the tcl-based client programs and client libraries
that you'll need to access a PostgreSQL database management system
server.  This package contains the tcl client libraries,
as well as pgaccess, a wish-based utility for manipulating PostgreSQL databases.

%package odbc
Summary: The ODBC driver needed for accessing a PostgreSQL server.
Group: Databases
Requires: postgresql = %{version}

%description odbc
Postgresql-odbc includes the odbc driver and sample configuration files
that you'll need to access a PostgreSQL database management system
server.

%package perl
Summary: The perl-based client programs needed for accessing a PostgreSQL server.
Group: Development/Databases
Requires: perl >= 5.004-4, postgresql = %{version}

%description perl
postgresql-perl includes the perl-based client programs and client libraries
that you'll need to access a PostgreSQL database management system
server.

%package python
Summary: The python-based client programs needed for accessing a PostgreSQL server.
Group: Development/Databases
Requires: python >= 1.5, postgresql = %{version}

%description python
postgresql-python includes the python-based client programs and client libraries
that you'll need to access a PostgreSQL database management system
server.

%package jdbc
Summary: The java-based client programs needed for accessing a PostgreSQL server.
Group: Development/Databases
Requires: postgresql = %{version}

%description jdbc
postgresql-jdbc includes the jar file that you'll need to access a PostgreSQL
database management system server.

%package test
Summary: The test suite distributed with PostgreSQL.
Group: Databases
Requires: postgresql = %{version}

%description test
postgresql-test includes the source and pre-built binaries of the various tests
included with PostgreSQL, such as the regression tests and benchmarks.

%prep
%setup -q -a 1
mkdir -p howto
tar xyf %{SOURCE5} -C howto

%ifarch alpha
%patch0 -p1
%endif
%patch1 -p1
%patch2 -p1
%patch4 -p0
%patch5 -p1

%build
pushd src
%ifarch alpha
CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=/usr \
	--enable-hba --enable-locale \
	--with-perl \
	--with-tcl --with-tk --with-x \
	--with-odbc --with-java \
	--with-python --with-template=linux_alpha
%else
CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=/usr \
	--enable-hba --enable-locale \
	--with-perl \
	--with-tcl --with-tk --with-x \
	--with-odbc --with-java \
	--with-python
%endif

make all
pushd interfaces/python
cp /usr/lib/python1.5/config/Makefile.pre.in .
echo *shared* > Setup
echo _pg pgmodule.c -I../../include -I../libpq -L../libpq -lpq -lcrypt >> Setup
make -f Makefile.pre.in boot
make
popd
popd

make all PGDOCS=unpacked -C doc

pushd src/test
make all
popd

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/{include/pgsql,lib,bin}
mkdir -p $RPM_BUILD_ROOT/usr/lib/perl5/site_perl/%{_arch}-linux/auto/Pg
make POSTGRESDIR=$RPM_BUILD_ROOT/usr PREFIX=$RPM_BUILD_ROOT/usr -C src install
make POSTGRESDIR=$RPM_BUILD_ROOT/usr PREFIX=$RPM_BUILD_ROOT/usr -C src/man install
make POSTGRESDIR=$RPM_BUILD_ROOT/usr PREFIX=$RPM_BUILD_ROOT/usr -C src/interfaces/perl5 install
# Get rid of the packing list generated by the perl Makefile, and build my own...
find $RPM_BUILD_ROOT/usr/lib/perl5 -name .packlist -exec rm -f {} \;
echo '%defattr(-,root,root)' > perlfiles.list
find $RPM_BUILD_ROOT/usr/lib/perl5 -type f -print | \
	sed -e "s|$RPM_BUILD_ROOT/|/|g" >> perlfiles.list
find $RPM_BUILD_ROOT/usr/lib/perl5 -type d -name Pg -print | \
	sed -e "s|$RPM_BUILD_ROOT/|%dir /|g" >> perlfiles.list
make -C doc
#make -C doc man
# Newer man pages from Thomas Lockhart
pushd $RPM_BUILD_ROOT/usr/man
tar xyf %{SOURCE6}
popd

# Move all includes beneath /usr/include/pgsql.
pushd $RPM_BUILD_ROOT/usr/include
rm -rf include
for f in *.h access commands executor lib libpq libpq++ port utils ; do
    mv $f pgsql
done
popd

# Move all templates/examples beneath /usr/lib/pgsql
pushd $RPM_BUILD_ROOT/usr/lib
  mkdir -p pgsql
  mv *.source *.sample *.description pgsql
popd

# Get interface-specific tests and examples, and stuff under /usr/lib/pgsql
pushd src/interfaces
mkdir -p $RPM_BUILD_ROOT/usr/lib/pgsql/perl5
cp -a perl5/test.pl perl5/eg $RPM_BUILD_ROOT/usr/lib/pgsql/perl5
mkdir -p $RPM_BUILD_ROOT/usr/lib/pgsql/python
cp -a python/tutorial $RPM_BUILD_ROOT/usr/lib/pgsql/python
popd

# pgaccess installation
install -m 755 pgaccess/pgaccess $RPM_BUILD_ROOT/usr/bin
mkdir -p $RPM_BUILD_ROOT/usr/lib/pgsql/pgaccess
install -m 644 pgaccess/main.tcl $RPM_BUILD_ROOT/usr/lib/pgsql/pgaccess
tar cf - pgaccess/lib pgaccess/images | tar xf - -C $RPM_BUILD_ROOT/usr/lib/pgsql
cp -a pgaccess/doc/html   doc/pgaccess
cp    pgaccess/demo/*.sql doc/pgaccess

# Python
pushd src/interfaces/python
# Makefile.pre.in doesn't yet support .py files anyway, so we stick to a manual installation
  mkdir -p $RPM_BUILD_ROOT/usr/lib/python1.5/site-packages
  install -m 755 _pgmodule.so *.py $RPM_BUILD_ROOT/usr/lib/python1.5/site-packages/
popd

# Java/JDBC
# We know that JDK1.2 is pre-beta at this time, so install the JDK1.1-compatible driver
# as well as the JDK1.2 compatible driver.
# The user will have to set a CLASSPATH to find it here, but not sure where else to put it...
install -m 755 %{SOURCE2} $RPM_BUILD_ROOT/usr/lib/pgsql
install -m 755 %{SOURCE3} $RPM_BUILD_ROOT/usr/lib/pgsql

chmod 644 $RPM_BUILD_ROOT/usr/man/*/*
chmod +x $RPM_BUILD_ROOT/usr/lib/lib*.so.*
install -d $RPM_BUILD_ROOT/etc/rc.d/init.d
install -m 755 %{SOURCE4} $RPM_BUILD_ROOT/etc/rc.d/init.d/postgresql

# Move the PL's to the right place
mv $RPM_BUILD_ROOT/usr/lib/pl*.so $RPM_BUILD_ROOT/usr/lib/pgsql

## Removed the code for the data subpackage.

mkdir -p $RPM_BUILD_ROOT/var/lib/pgsql

# tests. There are many files included here that are unnecessary, but include
# them anyway for completeness.

cp -a src/test $RPM_BUILD_ROOT/usr/lib/pgsql
install -m 0755 src/config.guess $RPM_BUILD_ROOT/usr/lib/pgsql
install -m 0755 contrib/spi/refint.so $RPM_BUILD_ROOT/usr/lib/pgsql/test/regress
install -m 0755 contrib/spi/autoinc.so $RPM_BUILD_ROOT/usr/lib/pgsql/test/regress

# Upgrade scripts and man page.  Beta test.
pushd $RPM_BUILD_ROOT
tar xyf %{SOURCE8}
popd

# Fix some more documentation
# no need for the OS2 client
rm -rf contrib/os2client
gzip doc/internals.ps
cp %{SOURCE7} README.rpm

# Strip 'em all
#strip $RPM_BUILD_ROOT/usr/bin/* || :

perl -p -i -e 's/Pg\.3/Pg\.3\.bz2/g' $RPM_BUILD_DIR/%{name}-%{version}/perlfiles.list


%pre
# Need to make backups of some executables if an upgrade
# They will be needed to do a dump of the old version's database.
# All output redirected to /dev/null.

if [ $1 -gt 1 ]
then
   mkdir -p /usr/lib/pgsql/backup > /dev/null
   pushd /usr/bin > /dev/null
   cp -fp postmaster postgres pg_dump pg_dumpall psql /usr/lib/pgsql/backup > /dev/null
   popd > /dev/null
   pushd /usr/lib > /dev/null
   cp -fp libpq.* /usr/lib/pgsql/backup > /dev/null
   popd > /dev/null
fi

%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%pre server
useradd -M -o -r -d /var/lib/pgsql -s /bin/bash \
	-c "PostgreSQL Server" -u 40 postgres >/dev/null 2>&1 || :

%post -p /sbin/ldconfig server

%preun server
if [ $1 = 0 ] ; then
	chkconfig --del postgresql
fi

%postun server
/sbin/ldconfig
if [ $1 = 0 ] ; then
	userdel postgres >/dev/null 2>&1 || : 
fi

%post -p /sbin/ldconfig odbc
%postun -p /sbin/ldconfig odbc

%post -p /sbin/ldconfig tcl
%postun -p /sbin/ldconfig tcl

%clean
rm -rf $RPM_BUILD_ROOT
rm -f perlfiles.list

%files
%defattr(-,root,root)
%doc doc/FAQ doc/FAQ_Linux doc/README* 
%doc COPYRIGHT README HISTORY doc/bug.template doc/FAQ_Linux
%doc contrib doc/unpacked/* 
%doc doc/*.ps.gz
%doc howto
%doc README.rpm
%attr(755,root,root) /usr/lib/libpq.so*
%attr(755,root,root) /usr/lib/libecpg.so*
%attr(755,root,root) /usr/lib/libpq++.so*
/usr/bin/createdb
/usr/bin/createlang
/usr/bin/createuser
/usr/bin/destroydb
/usr/bin/destroylang
/usr/bin/destroyuser
/usr/bin/pg_dump
/usr/bin/pg_dumpall
/usr/bin/pg_id
/usr/bin/psql
/usr/bin/vacuumdb
/usr/man/man1/createdb.1*
/usr/man/man1/createlang.1*
/usr/man/man1/createuser.1*
/usr/man/man1/destroydb.1*
/usr/man/man1/destroylang.1*
/usr/man/man1/destroyuser.1*
/usr/man/man1/pg_dump.1*
/usr/man/man1/pg_dumpall.1*
/usr/man/man1/psql.1*
/usr/man/manl/*

%files server
%defattr(-,root,root)
%config /etc/rc.d/init.d/postgresql
/usr/bin/cleardbdir
/usr/bin/initdb
/usr/bin/initlocation
/usr/bin/ipcclean
/usr/bin/pg_passwd
/usr/bin/pg_version
/usr/bin/postgres
/usr/bin/postgresql-dump
/usr/bin/postmaster
/usr/man/man1/cleardbdir.1*
/usr/man/man1/initdb.1*
/usr/man/man1/initlocation.1*
/usr/man/man1/ipcclean.1*
/usr/man/man1/pg_passwd.1*
/usr/man/man1/postgres.1*
/usr/man/man1/postmaster.1*
/usr/man/man1/pg_upgrade.1*
/usr/man/man5/pg_hba.conf.5*
/usr/man/man8/postgresql-dump.8*
/usr/lib/pgsql/global1.bki.source
/usr/lib/pgsql/global1.description
/usr/lib/pgsql/local1_template1.bki.source
/usr/lib/pgsql/local1_template1.description
/usr/lib/pgsql/pg_geqo.sample
/usr/lib/pgsql/pg_hba.conf.sample
/usr/lib/pgsql/plpgsql.so
%attr(-,postgres,postgres) %dir /usr/lib/pgsql/backup
/usr/lib/pgsql/backup/pg_dumpall_new
%attr(-,postgres,postgres) %dir /var/lib/pgsql

%files devel
%defattr(-,root,root)
/usr/include/pgsql
/usr/man/man3/*
/usr/bin/ecpg
/usr/man/man1/ecpg.1*
/usr/lib/lib*.a

%files tcl
%defattr(-,root,root)
%attr(755,root,root) /usr/lib/libpgtcl.so*
%doc doc/pgaccess/*
/usr/lib/pgsql/pgaccess
/usr/bin/pgaccess
/usr/bin/pgtclsh
/usr/bin/pgtksh
/usr/man/man1/pgaccess.1*
/usr/man/man1/pgtclsh.1*
/usr/man/man1/pgtksh.1*
/usr/lib/pgsql/pltcl.so

%files odbc
%defattr(-,root,root)
%attr(755,root,root) /usr/lib/libpsqlodbc.so*

%files -f perlfiles.list perl
%defattr(-,root,root)
%dir /usr/lib/perl5/site_perl/%{_arch}-linux/auto
/usr/lib/pgsql/perl5

%files python
%defattr(-,root,root)
/usr/lib/python1.5/site-packages/_pgmodule.so
/usr/lib/python1.5/site-packages/*.py
/usr/lib/pgsql/python

%files jdbc
%defattr(-,root,root)
/usr/lib/pgsql/jdbc6.5-1.1.jar
/usr/lib/pgsql/jdbc6.5-1.2.jar

%files test
%defattr(-,postgres,postgres)
%attr(755,postgres,postgres)/usr/lib/pgsql/config.guess
/usr/lib/pgsql/test/*

%changelog
* Sun Apr 2 2000 John Buswell <johnb@mandrakesoft.com> 6.5.3-1mdk
- 6.5.3
- Sparc64 patch added
- spec-helper
- fixed groups

* Wed Jan 26 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 6.5.2-3mdk
- Update config.sub for alpha.

* Thu Nov 04 1999 Axalon Bloodstone <axalon@linux-mandrake.com>
- defattr for -perl pkg

* Sun Oct 31 1999 Axalon Bloodstone <axalon@linux-mandrake.com>
- 6.5.2 (r)

# Last redhat merge
#* Sat Sep 25 1999 Dale Lovelace <dale@redhat.com>
